/*UT Awards

*/


#include <string>
#include <admin>
#include <adminlib>

#define ACCESS_CONSOLE	131072

new g_SoundFile[MAX_TEXT_LENGTH]="sound/misc/";
new g_maxplayers;

////////////////////////
//// Zeitunabhngig ////
////////////////////////

//Anzahl der AWARDS
#define MAX_KILLS	6

//gezhlt wird ab 0. Ergo gesamt = 5+1

//Anzahl der notwendigen Kills fr AWARD
new g_Kills1[MAX_KILLS]={
	4,
	5,
	6,
	7,
	8,
	9
};

//Nachricht fr AWARDS
new g_Announce1[MAX_KILLS][MAX_TEXT_LENGTH]={
	"is on a killing spree!",
	"is on a rampage!",
	"is dominating!",
	"is unstoppable!",
	"is GODLIKE!",
	"is WICKED SICK!"
};

//Sound fr AWARD
new g_Sound1[MAX_KILLS][MAX_TEXT_LENGTH]={
	"killingspree.wav",
	"rampage.wav",
	"dominating.wav",
	"unstoppable.wav",
	"godlike.wav",
	"wickedsick.wav"
};

//Farbe der typesay Anzeige
new g_Color1[3]={
	0,100,200
};

////////////////////////
////  Zeitabhngig  ////
////////////////////////
#define MAX_TIME_KILLS	7

//gezhlt wird ab 0. Ergo gesamt = 4+1

new g_Kills2[MAX_TIME_KILLS]={
	2,
	3,
	4,
	5,
	6,
	7,
	8
};

new g_Announce2[MAX_TIME_KILLS][]={
	"Double Kill!",
	"Multi Kill!",
	"Mega Kill!!",
	"ULTRA KILL!!",
	"M O N S T E R  K I L L !!!",
	"L U D I C R O U S  K I L L !!!",
	"H  O  L  Y   S  H  I  T !"
};

new g_Sound2[MAX_TIME_KILLS][]={
	"doublekill.wav",
	"multikill.wav",
	"megakill.wav",
	"ultrakill.wav",
	"monsterkill.wav",
	"ludicrouskill.wav",
	"holyshit.wav"
};

//Neu: Auf 5 s gesetzt
new g_KillTime=5;

//Farbe der typesay Anzeige
new g_Color2[3]={
	255,000,000
};

////////////////////////
////    sonstige    ////
////////////////////////

new g_UserKills[MAX_PLAYERS];
new g_UserTimeKills[MAX_PLAYERS];
new g_UserTimer[MAX_PLAYERS];
new g_UserTimeKillPlayed[MAX_PLAYERS];

public plugin_init() {
	plugin_registerinfo("Ultimate Killingspree","Announces Doublekills, Monsterkills etc.","0.8");
	plugin_registercmd("uk_kill","uk_kill",ACCESS_CONSOLE);
	exec( "logd_reg 57 admin_command uk_kill" );		/*KILL-EVENT*/
	plugin_registercmd("uk_world","uk_world",ACCESS_CONSOLE);
	exec( "logd_reg 62 admin_command uk_world" );		/*WORLD-EVENT*/
	g_maxplayers=maxplayercount();
	return PLUGIN_CONTINUE;
}

public uk_kill(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	new Weapon[MAX_NAME_LENGTH];
	new Attacker[MAX_NAME_LENGTH];
	new Victim[MAX_NAME_LENGTH];
	new sAID[3];
	new sVID[3];
	new iAID;
	new iVID;
	new iTeamA;
	new iTeamV;
	
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	
	strsplit(Data," ",sAID,3,sVID,3,Weapon,MAX_NAME_LENGTH);
	
	iAID=strtonum(sAID);
	iVID=strtonum(sVID);

	if(playerinfo(iAID,Attacker,MAX_NAME_LENGTH,_,_,iTeamA)){
		if(playerinfo(iVID,Victim,MAX_NAME_LENGTH,_,_,iTeamV)){
			//Teamkillcheck
			if(iTeamA!=iTeamV){
				//Kills zhlen, NEU: Fngt von vorne an, wenn MAX erreicht.
				if(g_UserKills[iAID]<g_Kills1[MAX_KILLS-1]){
					g_UserKills[iAID]+=1;
				}else{
					g_UserKills[iAID]=g_Kills1[3];
				}
				
				g_UserTimeKills[iAID]+=1;
				
				//snprintf(Data,MAX_DATA_LENGTH,"%s - KILLS: %i(%i) - TIMEKILLS: %i",Data,g_UserKills[iAID],g_Kills1[MAX_KILLS-1],g_UserTimeKills[iAID]);
				//say(Data);

				//Timer fr zeitabhngige Kills starten, wenn noch nicht vorhanden
				if(!g_UserTimer[iAID]){
					g_UserTimer[iAID]=1;
					//NEU: Jede Sekunde prfen, insgesamt g_KillTime+1 mal
					set_timer("check_timer",1,g_KillTime+1,sAID);
				}
				
				//berprfen, ob ein zeitunabhngiger AWARD vorliegt
				check_kills(iAID,0);
			}else{
				//Teamkill abziehen
				g_UserKills[iAID]-=1;
				g_UserTimeKills[iAID]-=1;
			}
			//Kills des toten Spieler nullen
			g_UserKills[iVID]=0;
			
			//NEU: Die Timekills lassen wir mal weiterlaufen und werden im Timer selber genullt.
			//Er kann ja kurz vor seinem Tod in einer Sekunde 2 Kills gemacht haben.
			//g_UserTimeKills[iVID]=0;
			//g_UserTimer[iVID]=0;
		}
	}
	return PLUGIN_CONTINUE;
}

public check_timer(Timer,Repeat,HLName,HLParam) {
	//new Data[MAX_DATA_LENGTH];
	new User[3];
	new iUser;
	
	convert_string(HLParam,User,3);
	iUser=strtonum(User);
	
	//snprintf(Data,MAX_DATA_LENGTH,"Timer for %i - Rep: %i - Timekills: %i", iUser, Repeat, g_UserTimeKills[iUser]);
	//say(Data);
	
	//NEU: Jedesmal berprfen, ob ein zeitabhngiger AWARD vorliegt//
	check_kills(iUser,1);
	
	//NEU:Timerrepeat abgelaufen, hier jetzt UserTimeKills nullen
	if(Repeat==1){
		//snprintf(Data,MAX_DATA_LENGTH,"Reset Timer for %i", iUser);
		//say(Data);
		g_UserTimer[iUser]=0;
		g_UserTimeKills[iUser]=0;
		g_UserTimeKillPlayed[iUser]=0;
	}
}
	
check_kills(UserIndex,ID){
	new Player[MAX_NAME_LENGTH];
	new i;
	if(playerinfo(UserIndex,Player,MAX_NAME_LENGTH)){
		if(ID){
			//AWARD fr zeitabhngige Kills prfen
			for(i=0;i<MAX_TIME_KILLS;i++){
				if(g_Kills2[i]==g_UserTimeKills[UserIndex]){
					//Damit der selbe Sound nicht immer wieder abgespielt wird.
					if(g_UserTimeKillPlayed[UserIndex]!=g_Kills2[i]){
						sound_target_a(Player,g_Sound2[i],g_Announce2[i],ID);
						g_UserTimeKillPlayed[UserIndex]=g_Kills2[i];
						break;
					}
				}
			}
			//NEU: Wird im Timer selber auf 0 gesetzt
			//g_UserTimeKills[UserIndex]=0;
		}else{
			//AWARD fr zeitunabhngige Kills prfen
			for(i=0;i<MAX_KILLS;i++){
				if(g_Kills1[i]==g_UserKills[UserIndex]){
					sound_target_a(Player,g_Sound1[i],g_Announce1[i],ID);
					break;
				}
			}
		}
	}
}

sound_target_a(UserName[],WavFile[],Msg[],ID){
	new Text[MAX_DATA_LENGTH];
	new Sound[MAX_DATA_LENGTH];

	snprintf(Text,MAX_DATA_LENGTH,"%s %s",UserName,Msg);
	snprintf(Sound,MAX_DATA_LENGTH,"%s%s",g_SoundFile,WavFile);
	
	//NEU: Messages: Timekills nur an Angreifer, sonst an alle
	//NEU: Sounds: Immer nur an den Angreifer
	if(ID){
		centersayex(UserName,Text,10,g_Color2[0],g_Color2[1],g_Color2[2]);
		speakto(UserName,Sound);
	}else{
		centersay(Text,10,g_Color1[0],g_Color1[1],g_Color1[2]);
		playsound(UserName,Sound);
	}
	
	//new Player[MAX_NAME_LENGTH];
	//new i;
	//for(i=1;i<=g_maxplayers;i++){
	//	if(playerinfo(i,Player,MAX_NAME_LENGTH)){
	//		speakto(Player,Data);
	//	}
	//}
}

//Kills der Spieler, die den Server verlassen oder neu connecten, nullen
public plugin_disconnect(HLUserName,UserIndex) {
	g_UserKills[UserIndex]=0;
	g_UserTimeKills[UserIndex]=0;
	g_UserTimer[UserIndex]=0;
	g_UserTimeKillPlayed[UserIndex]=0;
}
	
public plugin_connect(HLUserName,HLIP, UserIndex) {
	g_UserKills[UserIndex]=0;
	g_UserTimeKills[UserIndex]=0;
	g_UserTimer[UserIndex]=0;
	g_UserTimeKillPlayed[UserIndex]=0;
}

//Kills nach jeder Spielrunde resetten
public uk_world(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	new i;
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	
	//NEU: resetround gelscht, da es nie 1 sein kann...
	//Nur Reset bei Restart Round bzw. Game_Commencing. Bei Tod g_UserKills reset. TimeKills reset im Timer himself.
	if(Data[8]=='R' || Data[0]=='G'){
		for(i=0;i<=g_maxplayers;i++){
			g_UserKills[i]=0;
			g_UserTimeKills[i]=0;
			g_UserTimer[i]=0;
			g_UserTimeKillPlayed[i]=0;
		}
	}
	return PLUGIN_CONTINUE;
}